VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CTimerWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'****************************************************************
'*  VB file:   CTimerWrapper.cls
'*
'*  Minimal class wrapper for Win32 API Timer Function
'*  in VB5
'*
'*
'*  Copyright (c) 1998, Ray Mercer.  All rights reserved.
'****************************************************************
Public Event Timer(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
Private Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private m_TIMER_ID As Long
Private m_hTimer As Long 'array of timer handles
Private m_hWnd  As Long 'array of parent hwnds


Public Sub Create(ByVal hwnd As Long)
    If m_hTimer Then
        Call StopTimer
        m_hTimer = 0
        Exit Sub ' no need to reallocate resources
    End If
    
    m_TIMER_ID = GetFreeTimerIndex
    Debug.Print "class ID:" & m_TIMER_ID & " is now passing itself to the bas module"
    Set mTimer.ClassPointer(m_TIMER_ID) = Me
    'store the hwnd for the Window which will use the timer
    m_hWnd = hwnd
End Sub
Public Sub Destroy()
    If m_hTimer Then Call StopTimer
    If m_TIMER_ID Then Set mTimer.ClassPointer(m_TIMER_ID) = Nothing
End Sub
Public Sub StartTimer(ByVal Interval As Long)
    If m_hTimer Then
        Call KillTimer(m_hWnd, m_TIMER_ID)
        m_hTimer = 0
    End If
    Debug.Print "TIMER ID #" & m_TIMER_ID & " is starting"
    m_hTimer = SetTimer(m_hWnd, m_TIMER_ID, Interval, AddressOf mTimer.TimerProc)
End Sub
Public Sub StopTimer()
    If m_hTimer Then
        Debug.Print "TIMER ID #" & m_TIMER_ID & " is being killed"
        Call KillTimer(m_hWnd, m_TIMER_ID)
        m_hTimer = 0
    End If
End Sub
Friend Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
    RaiseEvent Timer(hwnd, uMsg, idEvent, dwTime)
End Sub

Private Sub Class_Terminate()
    Call Destroy 'just in case user doesn't call
End Sub
