VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDownloader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim m_sRequest As String
Dim m_sSendHeaders As String
Dim m_bReadyState As Boolean
Dim m_bPauseDo As Boolean
Dim m_sProxyServer As String
Dim m_sProxyUser As String
Dim m_sProxyPassword As String
'Public HTTPObject As New XMLHTTP30
Public HTTPObject As New ServerXMLHTTP40

Public Enum eReadyState
    UNINITIALIZED = 0
    LOADING = 1
    LOADED = 2
    INTERACTIVE = 3
    COMPLETED = 4
End Enum

Public Event onReadyStateChanged(state As eReadyState)

Sub OnReadyStateChange()
Attribute OnReadyStateChange.VB_UserMemId = 0
     RaiseEvent onReadyStateChanged(HTTPObject.readyState)
End Sub


Public Function OpenUrlGET(sUrl As String, Optional sUser As String, Optional sPassword As String, Optional sRequest As String, Optional sSendHeaders As String)
    Dim i As Long, arrTmp() As String
    
    Debug.Print "GET " & sUrl & "?" & sRequest
    
    HTTPObject.Abort
    HTTPObject.setOption 2, 13056 ' Ignore all SSL errors
    
    If m_sProxyServer <> "" Then
        HTTPObject.setProxy SXH_PROXY_SET_PROXY, m_sProxyServer
    End If
    
    HTTPObject.OnReadyStateChange = Me
    HTTPObject.Open "GET", IIf(sRequest = "", sUrl, sUrl & "?" & sRequest), True, sUser, sPassword
    If m_sProxyServer <> "" Then If m_sProxyUser <> "" Or m_sProxyPassword <> "" Then HTTPObject.setProxyCredentials m_sProxyUser, m_sProxyPassword
    
    m_sRequest = sRequest
    m_sSendHeaders = sSendHeaders
    arrTmp = Split(m_sSendHeaders, vbCrLf)
    

    For i = 0 To UBound(arrTmp)
        HTTPObject.setRequestHeader Trim(Left(arrTmp(i), InStr(arrTmp(i), ":") - 1)), Trim(Mid(arrTmp(i), InStr(arrTmp(i), ":") + 1))
    Next i

    On Error Resume Next
    HTTPObject.sEnd
       
    HTTPObject.waitForResponse 30
    
    Debug.Print HTTPObject.Status
    Debug.Print HTTPObject.responseText
    
    OpenUrlGET = StrConv(HTTPObject.responseBody, vbUnicode)
End Function

Public Function OpenUrlPOST(sUrl As String, Optional sUser As String, Optional sPassword As String, Optional sRequest As String, Optional sSendHeaders As String)
    Dim i As Long, arrTmp() As String
    
    Debug.Print "POST " & sUrl & "?" & sRequest
    Debug.Print "USER: " & sUser & ", PASS: " & sPassword
    
    HTTPObject.Abort
    HTTPObject.setOption 2, 13056 ' Ignore all SSL errors
    
    If m_sProxyServer <> "" Then
        HTTPObject.setProxy SXH_PROXY_SET_PROXY, m_sProxyServer
    End If

    HTTPObject.OnReadyStateChange = Me
    'Nejak u POSTu nejde asynchroni rezim. Hlasi to Nespecifikovana chyba (80004005).
    'Ale zmenili jsme tridu u objektu a uz to facha!!! Ale vsude pisou,
    'ze tato trida se nema pouzivat na klientskych aplikacich, takze takova nouzovka
    HTTPObject.Open "POST", sUrl, True, sUser, sPassword
    If m_sProxyServer <> "" Then If m_sProxyUser <> "" Or m_sProxyPassword <> "" Then HTTPObject.setProxyCredentials m_sProxyUser, m_sProxyPassword
    
    m_sRequest = sRequest
    m_sSendHeaders = sSendHeaders
    arrTmp = Split(m_sSendHeaders, vbCrLf)
    
    For i = 0 To UBound(arrTmp)
        If Trim(Left(arrTmp(i), InStr(arrTmp(i), ":") - 1)) <> "" Then
            HTTPObject.setRequestHeader Trim(Left(arrTmp(i), InStr(arrTmp(i), ":") - 1)), Trim(Mid(arrTmp(i), InStr(arrTmp(i), ":") + 1))
        End If
    Next i
    'Pozor nema to rado, kdyz se tomu nastavi content-length http hlavicka
    
    On Error Resume Next
    HTTPObject.sEnd m_sRequest
    
    HTTPObject.waitForResponse 30
    
    Debug.Print HTTPObject.Status
    Debug.Print HTTPObject.responseText
    
    OpenUrlPOST = StrConv(HTTPObject.responseBody, vbUnicode)
End Function

Public Property Get responseText() As String
    On Error Resume Next
    responseText = HTTPObject.responseText
End Property

Public Property Get responseBody() As Variant
    responseBody = HTTPObject.responseBody
End Property

Public Property Get Status() As Integer
    On Error Resume Next
    Status = HTTPObject.Status
End Property

Public Property Get StatusText() As String
    On Error Resume Next
    StatusText = HTTPObject.StatusText
End Property

Public Function GetHeader(sHeaderName As String) As String
    GetHeader = HTTPObject.getResponseHeader(sHeaderName)
End Function

Private Sub Class_Initialize()
    'Set HTTPObject = New ServerXMLHTTP
End Sub

Private Function MyReadyState() As Object
    m_bPauseDo = True
    Dim i As Long
    Dim arrTmp() As String
    
    Select Case HTTPObject.readyState
        Case 1
            On Error Resume Next
            arrTmp = Split(m_sSendHeaders, vbCrLf)
            For i = 0 To UBound(arrTmp)
                HTTPObject.setRequestHeader Trim(Left(arrTmp(i), InStr(arrTmp(i), ":") - 1)), Trim(Mid(arrTmp(i), InStr(arrTmp(i), ":") + 1))
            Next i
            On Error GoTo 0
            If m_sRequest <> "" Then HTTPObject.setRequestHeader "Content-Length", CStr(Len(m_sRequest))
            If HTTPObject.readyState <> 4 Then HTTPObject.sEnd m_sRequest
        Case 4
            m_bReadyState = True
    End Select
    
    m_bPauseDo = False
End Function

Private Sub Class_Terminate()
    HTTPObject.Abort
    Set HTTPObject = Nothing
End Sub

Public Property Let ProxyServer(sProxyServer As String)
    m_sProxyServer = sProxyServer
End Property

Public Property Get ProxyServer() As String
    ProxyServer = m_sProxyServer
End Property

Public Property Let ProxyUserName(sProxyUserName As String)
    m_sProxyUser = sProxyUserName
End Property

Public Property Get ProxyUserName() As String
    ProxyUserName = m_sProxyUser
End Property

Public Property Let ProxyPassword(sProxyPassword As String)
    m_sProxyPassword = sProxyPassword
End Property

Public Property Get ProxyPassword() As String
    ProxyPassword = m_sProxyPassword
End Property
