Attribute VB_Name = "mTimer"
Option Explicit
'****************************************************************
'*  VB file:   mTimer.bas
'*
'*  Callback function for receiving Win32 Timer callbacks
'*  in VB5
'*
'*  Copyright (c) 1998, Ray Mercer.  All rights reserved.
'****************************************************************

'Create an instance of our Class in the BAS file
Public ClassPointer() As CTimerWrapper
Private numAllocatedTImers As Long


Public Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
    'On Error Resume Next
    If Not ClassPointer(idEvent) Is Nothing Then
        Call ClassPointer(idEvent).TimerProc(hwnd, uMsg, idEvent, dwTime)
    End If
End Sub


Public Function GetFreeTimerIndex() As Long
'returns a timer ID
    Dim i As Long
    
    'first check and see if there are any empty timer slots
    If numAllocatedTImers Then
        For i = 1 To UBound(ClassPointer)
            If ClassPointer(i) Is Nothing Then 'check to see if any of the timers have been set to nothing and reuse the index
                GetFreeTimerIndex = i
                Exit Function
            End If
        Next i
        'if we got here we need to increase the size of the array
        numAllocatedTImers = numAllocatedTImers + 1
        ReDim Preserve ClassPointer(1 To numAllocatedTImers)
        GetFreeTimerIndex = UBound(ClassPointer)
    Else
        'no active timers - let's create a new slot
        numAllocatedTImers = numAllocatedTImers + 1
        ReDim Preserve ClassPointer(1 To numAllocatedTImers)
        GetFreeTimerIndex = UBound(ClassPointer)
    End If
    
        
    
End Function
