Attribute VB_Name = "modHTML"
Option Explicit

Public Function HTML2Text(ByVal OrigHTML As String, _
  Optional ByVal ImgText As String = "") As String

  ' ImgText: Text, der statt Bildern eingefgt wird.
  '         Sonderinhalte: %imgsrc fr Bilddateiname
  '                        %imgalt fr Alt-Text

  Dim CurrChar As String
  Dim NoHTML As String
  Dim hRef As String
  Dim x As Integer
  Dim z As Integer
  Dim imgFile As String
  Dim imgAlt As String
  Dim Params As String
  Dim BlockQuote As Boolean
  
  On Error Resume Next
  
  ' Prfen, ob -Tag vorhanden
  ' wenn ja befindet sich der relevante HTML-Teil
  ' zwischen <BODY> und </BODY>
  If InStr(LCase$(OrigHTML), "<body") > 0 Then
    OrigHTML = Mid$(OrigHTML, InStr(LCase$(OrigHTML), "<body"))
    OrigHTML = Mid$(OrigHTML, InStr(OrigHTML, ">") + 1)
    If InStr(LCase$(OrigHTML), "</body>") > 0 Then _
      OrigHTML = Left$(OrigHTML, InStr(LCase$(OrigHTML), _
      "</body>") - 1)
  End If

  ' HTML-Text zeichenweise "scannen"
  Do While Len(OrigHTML)
    CurrChar = Left$(OrigHTML, 1)
    OrigHTML = Mid$(OrigHTML, 2)
    Select Case CurrChar
      Case " "
        OrigHTML = LTrim$(OrigHTML)
      Case vbCr, vbLf
        If Right$(NoHTML, 1) <> " " And _
          Right$(NoHTML, 2) <> vbCrLf Then _
          CurrChar = " " Else CurrChar = ""
        If Left$(OrigHTML, 1) = vbLf Then _
          OrigHTML = Mid$(OrigHTML, 2)
        OrigHTML = LTrim$(OrigHTML)
        
      ' HTML-Steuerzeichen
      Case "<"
        CurrChar = ""
        If InStr(OrigHTML, ">") > 0 Then
          CurrChar = Left$(OrigHTML, InStr(OrigHTML, ">") - 1)
          OrigHTML = Mid$(OrigHTML, InStr(OrigHTML, ">") + 1)

          If InStr(CurrChar, " ") > 0 Then
            Params = ReplaceChars(Trim$(Mid$(CurrChar, _
              InStr(CurrChar, " ") + 1)), vbCrLf, "")
            CurrChar = Left$(CurrChar, InStr(CurrChar, " ") - 1)
          Else
            Params = ""
          End If
          Dim ParamColl As Collection

          Select Case LCase$(CurrChar)
            Case "p"
              If Right$(NoHTML, 4) <> vbCrLf & vbCrLf Then _
                CurrChar = vbCrLf & vbCrLf Else CurrChar = ""
            Case "/div"
              If Right$(NoHTML, 2) <> vbCrLf Then _
                CurrChar = vbCrLf Else CurrChar = ""
            Case "br"
              CurrChar = vbCrLf
            Case "ul", "/ul", "ol", "/ol"
              CurrChar = vbCrLf
            Case "li"
              CurrChar = vbCrLf & "   - "
            Case "blockquote"
              BlockQuote = True
              CurrChar = ""
            Case "/blockquote"
              BlockQuote = False
              CurrChar = ""
            Case "img"
              If Len(ImgText) > 0 Then
                Set ParamColl = StripByCharAndQuotes(Params, " ")
                imgAlt = ""
                imgFile = ""
                For z = 1 To ParamColl.Count
                  If LCase$(Left$(ParamColl(z), 4)) = "src=" Then
                    imgFile = StripQuotes(Mid$(ParamColl(z), 5))
                  ElseIf LCase$(Left$(ParamColl(z), 4)) = "alt=" Then
                    imgAlt = StripQuotes(Mid$(ParamColl(z), 5))
                  End If
                  If Len(imgAlt) > 0 And Len(imgFile) > 0 Then Exit For
                Next
                If Len(Trim$(imgAlt)) = 0 Then _
                  imgAlt = "Image " & imgFile
                ImgText = ReplaceChars(ImgText, "%imgalt", imgAlt)
                ImgText = ReplaceChars(ImgText, "%imgsrc", imgFile)

                CurrChar = " " & ImgText & " "
              Else
                CurrChar = ""
              End If
            Case "a"
              Set ParamColl = StripByCharAndQuotes(Params, " ")
              hRef = ""
              For z = 1 To ParamColl.Count
                If LCase$(Left$(ParamColl(z), 5)) = "href=" Then
                  hRef = StripQuotes(Mid$(ParamColl(z), 6))
                  Exit For
                End If
              Next
              CurrChar = ""
            Case "/a"
              CurrChar = ""
              If Len(Trim$(hRef)) > 0 Then
                If LCase$(Left$(hRef, 7)) = "mailto:" Then _
                  hRef = Mid$(hRef, 8)
                If LCase$(Right$(Trim$(NoHTML), _
                  Len(hRef))) <> LCase$(hRef) Then
                  If Not (LCase$(Left$(hRef, 7)) = "http://" And _
                   LCase$(Right$(Trim$(NoHTML), _
                   Len(hRef) - 7)) = LCase$(Mid$(hRef, 8))) Then
                    CurrChar = " [" & hRef & "]"
                    hRef = ""
                  End If
                End If
              End If
            Case "hr"
              CurrChar = vbCrLf
              For x = 1 To 70
                CurrChar = CurrChar & "-"
              Next
              CurrChar = CurrChar & vbCrLf
            Case "sigboundary"
              CurrChar = vbCrLf & "-- " & vbCrLf
            Case "script"
              CurrChar = ""
              If InStr(LCase$(OrigHTML), "</script>") > 0 Then _
                OrigHTML = Mid$(OrigHTML, InStr(LCase$(OrigHTML), _
                  "</script>"))
            Case "pre"
              CurrChar = vbCrLf
              If InStr(LCase$(OrigHTML), "</pre>") > 0 Then
                CurrChar = CurrChar & Left$(OrigHTML, _
                  InStr(LCase$(OrigHTML), "</pre>") - 1)
                OrigHTML = Mid$(OrigHTML, InStr(LCase$(OrigHTML), _
                  "</pre>"))
              End If
              CurrChar = CurrChar & vbCrLf
            Case Else
              CurrChar = ""
          End Select
        End If
      Case "&"
        If InStr(OrigHTML, ";") > 0 And (InStr(OrigHTML, ";") < _
          InStr(OrigHTML, " ") Or InStr(OrigHTML, " ") = 0) Then
          CurrChar = Left$(OrigHTML, InStr(OrigHTML, ";") - 1)
          OrigHTML = Mid$(OrigHTML, InStr(OrigHTML, ";") + 1)

          Select Case CurrChar
            Case "amp"
              CurrChar = "&"
            Case "quot"
              CurrChar = """"
            Case "lt"
              CurrChar = "<"
            Case "gt"
              CurrChar = ">"
            Case "nbsp"
              CurrChar = " "
            Case "Auml"
              CurrChar = ""
            Case "auml"
              CurrChar = ""
            Case "iexcl"
              CurrChar = "?"
            Case "cent"
              CurrChar = "?"
            Case "pound"
              CurrChar = "?"
            Case "curren"
              CurrChar = ""
            Case "yen"
              CurrChar = "?"
            Case "brvbar"
              CurrChar = "|"
            Case "sect"
              CurrChar = ""
            Case "uml"
              CurrChar = ""
            Case "copy"
              CurrChar = ""
            Case "ordf"
              CurrChar = "^(a)"
            Case "laquo"
              CurrChar = ""
            Case "not"
              CurrChar = ""
            Case "reg"
              CurrChar = ""
            Case "macr"
              CurrChar = "?"
            Case "deg"
              CurrChar = ""
            Case "plusm"
              CurrChar = ""
            Case "sup2"
              CurrChar = "^(2)"
            Case "sup3"
              CurrChar = "^(3)"
            Case "acute"
              CurrChar = ""
            Case "micro"
              CurrChar = ""
            Case "para"
              CurrChar = ""
            Case "middot"
              CurrChar = ""
            Case "cedil"
              CurrChar = ""
            Case "sup1"
              CurrChar = "^(1)"
            Case "ordm"
              CurrChar = "^(o)"
            Case "raquo"
              CurrChar = ""
            Case "frac14"
              CurrChar = "1/4"
            Case "frac12"
              CurrChar = "1/2"
            Case "frac34"
              CurrChar = "3/4"
            Case "iquest"
              CurrChar = "?"
            Case "Agrave"
              CurrChar = "A`"
            Case "Aacute"
              CurrChar = ""
            Case "Acirc"
              CurrChar = ""
            Case "Atilde"
              CurrChar = "A~"
            Case "Aring"
              CurrChar = "A*"
            Case "AElig"
              CurrChar = "?"
            Case "Ccedil"
              CurrChar = ""
            Case "Egrave"
              CurrChar = "E`"
            Case "Eacute"
              CurrChar = ""
            Case "Ecirc"
              CurrChar = "E^"
            Case "Euml"
              CurrChar = ""
            Case "Igrave"
              CurrChar = "I`"
            Case "Iacute"
              CurrChar = ""
            Case "Icirc"
              CurrChar = ""
            Case "Iuml"
              CurrChar = "I"""
            Case "ETH"
              CurrChar = "?"
            Case "Ntilde"
              CurrChar = "N~"
            Case "Ograve"
              CurrChar = "O`"
            Case "Oacute"
              CurrChar = ""
            Case "Ocirc"
              CurrChar = ""
            Case "Otilde"
              CurrChar = "O~"
            Case "Ouml"
              CurrChar = ""
            Case "times"
              CurrChar = ""
            Case "Oslash"
              CurrChar = "?"
            Case "Ugrave"
              CurrChar = "U`"
            Case "Uacute"
              CurrChar = ""
            Case "Ucirc"
              CurrChar = "U^"
            Case "Uuml"
              CurrChar = ""
            Case "Yacute"
              CurrChar = ""
            Case "THORN"
              CurrChar = "?"
            Case "szlig"
              CurrChar = ""
            Case "agrave"
              CurrChar = "a`"
            Case "aacute"
              CurrChar = ""
            Case "acirc"
              CurrChar = ""
            Case "atilde"
              CurrChar = "a~"
            Case "aring"
              CurrChar = "a*"
            Case "aelig"
              CurrChar = "?"
            Case "ccedil"
              CurrChar = ""
            Case "egrave"
              CurrChar = "e`"
            Case "eacute"
              CurrChar = ""
            Case "ecirc"
              CurrChar = "e^"
            Case "euml"
              CurrChar = ""
            Case "igrave"
              CurrChar = "i`"
            Case "iacute"
              CurrChar = ""
            Case "icirc"
              CurrChar = ""
            Case "iuml"
              CurrChar = "i"""
            Case "eth"
              CurrChar = "?"
            Case "ntilde"
              CurrChar = "n~"
            Case "ograve"
              CurrChar = "o`"
            Case "oacute"
              CurrChar = ""
            Case "ocirc"
              CurrChar = ""
            Case "otilde"
              CurrChar = "o~"
            Case "ouml"
              CurrChar = ""
            Case "divide"
              CurrChar = ""
            Case "oslash"
              CurrChar = "?"
            Case "ugrave"
              CurrChar = "u`"
            Case "uacute"
              CurrChar = ""
            Case "ucirc"
              CurrChar = "u^"
            Case "uuml"
              CurrChar = ""
            Case "yacute"
              CurrChar = ""
            Case "thorn"
              CurrChar = "?"
            Case "yuml"
              CurrChar = "y"""
            Case Else
              CurrChar = "&" & CurrChar & ";"
          End Select
        End If
    End Select
    If Right$(CurrChar, 2) = vbCrLf And BlockQuote Then _
      CurrChar = CurrChar & "> "
    NoHTML = NoHTML & CurrChar
  Loop

  NoHTML = Trim$(NoHTML)

  Do While Left$(NoHTML, 2) = vbCrLf
    NoHTML = Trim$(Mid$(NoHTML, 3))
  Loop
  Do While Right$(NoHTML, 2) = vbCrLf
    NoHTML = Trim$(Left$(NoHTML, Len(NoHTML) - 2))
  Loop

  HTML2Text = NoHTML
End Function

Public Function ReplaceChars(ByVal OrgString _
  As String, ByVal ToReplace As String, _
  ByVal ToInsert As String) As String

  Dim ST As Long
  Dim newst As Long
  
  ST = 0
  Do While InStr(ST + 1, LCase$(OrgString), LCase$(ToReplace)) <> 0
    newst = InStr(ST + 1, LCase$(OrgString), LCase$(ToReplace))
    OrgString = Left$(OrgString, InStr(ST + 1, LCase$(OrgString), _
      LCase$(ToReplace)) - 1) & ToInsert & Mid$(OrgString, _
      InStr(ST + 1, LCase$(OrgString), LCase$(ToReplace)) + _
      Len(ToReplace))
    ST& = newst + Len(ToInsert) - 1
  Loop
  ReplaceChars = OrgString
End Function

Function StripByCharAndQuotes(ByVal OrgString _
  As String, StripChar As String) As Collection

  Dim Scoll As Collection
  Dim x As Long, Y As Long
  
  Set Scoll = New Collection
  Do
    x = InStr(OrgString, StripChar)
    Y = InStr(OrgString, Chr$(34))
    
    If Y > 0 And Y < x Then
      Y = InStr(Y + 1, OrgString, Chr$(34))
      Do While Y > x And Y > 0 And x > 0
        x = InStr(x + 1, OrgString, StripChar)
      Loop
    End If
    
    If x > 0 Then
      Scoll.Add Left$(OrgString, x - 1)
      OrgString = Mid$(OrgString, x + 1)
    Else
      Scoll.Add OrgString
      OrgString = ""
    End If
  Loop While Len(OrgString) > 0

  Set StripByCharAndQuotes = Scoll
  Set Scoll = Nothing
End Function

Private Function StripQuotes(ByVal sText _
  As String) As String

  If Left$(sText, 1) = Chr$(34) Then _
    sText = Mid$(sText, 2)
  If Right$(sText, 1) = Chr$(34) Then _
    sText = Left$(sText, Len(sText) - 1)
    StripQuotes = sText
End Function


