Attribute VB_Name = "modMain"
Option Explicit

Public Const csLatest_XML As String = "http://nyx.arcao.com/fenyx/latest.xml"
Public Const csPicturesURL As String = "http://i.nyx.cz/"
Public Const csClientURL_HTTP As String = "http://www.nyx.cz/code/client.php"
Public Const csClientURL_HTTPS As String = "https://www.nyx.cz/code/client.php"

Private Const SM_CXICON = 11
Private Const SM_CYICON = 12
Private Const SM_CXSMICON = 49
Private Const SM_CYSMICON = 50
Private Const ICON_SMALL = 0
Private Const ICON_BIG = 1
Private Const WM_SETICON = &H80
Private Const GW_OWNER = 4
Public Const LR_SHARED = &H8000&
Public Const IMAGE_ICON = 1
Private Const ICC_USEREX_CLASSES = &H200
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2

Private Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type

Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean
Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Public Declare Function LoadImageAsString Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal uType As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal fuLoad As Long) As Long
Public Declare Function LoadImageLong Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As Long, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Declare Function ShellExecute Lib "shell32" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function APIGetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function APIGetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long

Public bDebuge As Boolean

Public Function MakeVersion() As String
    MakeVersion = UCase(Hex(App.Major)) & UCase(Hex(App.Minor)) & "b" & UCase(Hex(App.Revision))
End Function

Public Function IsXMLHTTPReady(Obj As XMLHTTP) As Boolean
    'On Error GoTo err
    Dim sTemp As String
    IsXMLHTTPReady = False
    If Obj.readyState <> 4 Then Exit Function
    IsXMLHTTPReady = True
    sTemp = Obj.responseText
    'MsgBox sTemp
    Exit Function
err:
    IsXMLHTTPReady = False
End Function


Public Function CloseSelApp(ByVal ClassName As String, ByVal AppTitle As String)
'zavre urcenou ulohu
Dim winHwnd As Long
Dim RetVal As Long
Dim tmp As String

    Do
        DoEvents
        winHwnd = FindWindow(ClassName, AppTitle)
        If winHwnd <> 0 Then
           RetVal = PostMessage(winHwnd, &H10, 0&, 0&)
        End If
    Loop Until winHwnd = 0
End Function

Public Function FormatUnixTime(lUnixTime, sFormat) As String
    FormatUnixTime = Format(TimestampToDate(lUnixTime), sFormat)
End Function

Public Function InitCommonControlsVB() As Boolean
   On Error Resume Next
   Dim iccex As tagInitCommonControlsEx
   ' Ensure CC available:
   With iccex
       .lngSize = LenB(iccex)
       .lngICC = ICC_USEREX_CLASSES
   End With
   InitCommonControlsEx iccex
   InitCommonControlsVB = (err.Number = 0)
   On Error GoTo 0
End Function

Public Sub DrawIconFromRes(pic As PictureBox, lNum As Long, Optional lX As Long = 0, Optional lY As Long = 0)
    Dim hIcon As Long
    pic.Picture = LoadPicture()
    pic.AutoRedraw = True
    hIcon = LoadImageLong(App.hInstance, lNum, IMAGE_ICON, 32, 32, 0)
    DrawIcon pic.hdc, lX, lY, hIcon
    DestroyIcon hIcon
End Sub

Public Function ArrDataToStr(arrData As Variant) As String
    Dim i As Long, tmp As String
    
    For i = LBound(arrData) To UBound(arrData)
        tmp = tmp & Chr(arrData(i))
    Next i
    ArrDataToStr = tmp
End Function

Public Function AppDir()
    If Len(App.Path) = 3 Then
        AppDir = App.Path
    Else
        AppDir = App.Path & "\"
    End If
End Function

Public Function GetPathFromString(sPathIn As String) As String
    Dim i As Integer
   For i = Len(sPathIn) To 1 Step -1
      If InStr(":\", Mid$(sPathIn, i, 1)) Then Exit For
   Next
   GetPathFromString = Left$(sPathIn, i)
End Function

Public Sub MakeClearType(frm As Form)
    Dim Control As Object
   
    On Error Resume Next
    
    'MakeSystemFont frm, SystemCaptionFont
    
    For Each Control In frm.Controls
        If TypeOf Control Is VB.ComboBox Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.CommandButton Then
            MakeSystemFont Control, SystemMessageFont
        ElseIf TypeOf Control Is VB.DirListBox Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.DriveListBox Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.FileListBox Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.Frame Then
            MakeSystemFont Control, SystemMessageFont
        ElseIf TypeOf Control Is VB.CheckBox Then
            MakeSystemFont Control, SystemMessageFont
        ElseIf TypeOf Control Is VB.Label Then
            MakeSystemFont Control, SystemMessageFont
        ElseIf TypeOf Control Is VB.ListBox Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.Menu Then
            MakeSystemFont Control, SystemMenuFont
        ElseIf TypeOf Control Is VB.OptionButton Then
            MakeSystemFont Control, SystemMessageFont
        ElseIf TypeOf Control Is VB.TextBox Then
            MakeSystemFont Control, SystemMenuFont
        Else
            MakeSystemFont Control, SystemMenuFont
        End If
    Next
End Sub

Public Function isFormLoaded(sForm As String) As Boolean
    Dim lCount As Long
    isFormLoaded = False
    For lCount = 0 To Forms.Count - 1
        If Forms(lCount).name = sForm Then
            isFormLoaded = True
            Exit Function
        Else
            isFormLoaded = False
        End If
    Next lCount
End Function

Public Function ByteArrayToString(Bytes() As Byte) As String

    Dim iUnicode As Long, i As Long, j As Long
    On Error Resume Next
    i = UBound(Bytes)


    If (i < 1) Then
        'ANSI, just convert to unicode and retur
        '     n
        ByteArrayToString = StrConv(Bytes, vbUnicode)
        Exit Function
    End If

    i = i + 1
    'Examine the first two bytes
    CopyMemory iUnicode, Bytes(0), 2


    If iUnicode = Bytes(0) Then 'Unicode
        'Account for terminating null
        If (i Mod 2) Then i = i - 1
        'Set up a buffer to recieve the string
        ByteArrayToString = String$(i / 2, 0)
        'Copy to string
        CopyMemory ByVal StrPtr(ByteArrayToString), Bytes(0), i
    Else 'ANSI
        ByteArrayToString = StrConv(Bytes, vbUnicode)
    End If

End Function

Public Function RunNyxInBrowser(sUser As String, sPassword As String, sGetRequest As String, Optional bInvisible As Boolean, Optional sFormHTML As String, Optional bUseHTTPS As Boolean) As Boolean
    'On Error GoTo err
    Dim sTmp As String
    Dim fNum As Long
    Dim sFile As String
    Dim arrHash() As String

    'bUseHTTPS = True
    arrHash = getNyxHash(bUseHTTPS)

    sTmp = ArrDataToStr(LoadResData("login", 10))
    
    sTmp = Replace(sTmp, "{%username%}", sUser, 1, -1, vbTextCompare)
    sTmp = Replace(sTmp, "{%password%}", sPassword, 1, -1, vbTextCompare)
    sTmp = Replace(sTmp, "{%invisible%}", IIf(bInvisible, "1", "0"), 1, -1, vbTextCompare)
    sTmp = Replace(sTmp, "{%request%}", sGetRequest, 1, -1, vbTextCompare)
    
    sTmp = Replace(sTmp, "{%protocol%}", IIf(bUseHTTPS, "https", "http"), 1, -1, vbTextCompare)
    
    sTmp = Replace(sTmp, "{%hash1%}", arrHash(0), 1, -1, vbTextCompare)
    sTmp = Replace(sTmp, "{%hash2%}", arrHash(1), 1, -1, vbTextCompare)
    
    sFile = GetTempFileName("fen")
    fNum = FreeFile
    Open sFile For Binary As fNum
    Put fNum, , sTmp
    Close fNum
    
    'novej nyxlogin se stara, aby byl soubor smazan
    ShellExecute 0, "", AppDir & "nyxlogin.exe", sFile, 0&, 1
    
    RunNyxInBrowser = True
    Exit Function
err:
    RunNyxInBrowser = False
End Function

Public Function GetTempFileName(sPrefix As String) As String
    Dim sTemp As String
    sTemp = Space(260)
    APIGetTempFileName GetTempPath, sPrefix, 0, sTemp
    GetTempFileName = Trim(sTemp)
End Function

Public Function GetTempPath() As String
    Dim sTemp As String
    sTemp = Space(100)
    APIGetTempPath 100, sTemp
    GetTempPath = Trim(sTemp)
End Function

Public Function FormatTime(lTime As Long) As String
    Dim lMin As Long
    Dim lSec As Long
    
    lMin = lTime / 60
    lSec = lTime Mod 60
    FormatTime = CStr(lMin) & ":" & IIf(lSec < 10, 0 & CStr(lSec), CStr(lSec))
End Function

Public Function getNyxHash(Optional bUseHTTPS As Boolean) As String()
    Dim hash(0 To 1) As String
    
    Dim sContent As String
    
    Dim hItem1 As String
    Dim hItem2 As String
    Dim hItem3 As String
    
    Dim url As String
    
    Dim down As New clsDownloader
    
    url = IIf(bUseHTTPS, "https", "http") & "://www.nyx.cz/index.php"
        
    Randomize 12345
    
    down.OpenUrlGET url, frmMain.nyx.ProxyUserName, frmMain.nyx.ProxyPassword, "l=secure;n=" & Hex(CInt(Rnd * 10 ^ 4)), _
    "User-Agent:" & "feNyx" & MakeVersion & vbCrLf & _
    "Accept-Language: cs" & vbCrLf & _
    "Content-type: application/x-www-form-urlencoded"

    sContent = down.responseText
    
    hItem1 = ArrDataToStr(LoadResData("hash_sep_1", 10))
    hItem2 = ArrDataToStr(LoadResData("hash_sep_2", 10))
    hItem3 = ArrDataToStr(LoadResData("hash_sep_3", 10))
    
    hash(0) = HledejMezi(sContent, hItem1, hItem2, vbTextCompare)
    hash(1) = HledejMezi(sContent, hItem2, hItem3, vbTextCompare)
    
    'MsgBox sContent
    
    getNyxHash = hash
    
    'down = Null
End Function

Function MAKELONG(LoWord As Integer, HiWord As Integer) As Long
    MAKELONG = (HiWord * &H10000) Or (LoWord And &HFFFF&)
End Function

Public Function HledejMezi(sStr As String, sBegin As String, sEnd As String, Compare As VbCompareMethod) As String
    On Error Resume Next
    Dim sTmp As String
    Dim lBegin As Long, lEnd As Long
    
    lBegin = InStr(1, sStr, sBegin, Compare)
    
    If lBegin = 0 Then Exit Function
    
    lBegin = lBegin + Len(sBegin)
    
    lEnd = InStr(lBegin, sStr, sEnd, Compare)
    
    If lEnd = 0 Then Exit Function
    
    HledejMezi = Mid(sStr, lBegin, lEnd - lBegin)
End Function

Public Function Encrypt(text As String) As String
    Dim i As Long
    Dim ret As String
    Dim hexa As String
    If UCase(Left(text, 5)) = "$ENC$" Then
        Encrypt = text
        Exit Function
    End If
    
    ret = String(Len(text) * 2, "0")
    
    For i = 1 To Len(text)
        hexa = Hex(Asc(Mid(text, i, 1)) - 13)
        If Len(hexa) = 1 Then hexa = "0" & hexa
        Mid(ret, i * 2 - 1, 2) = hexa
    Next i
    
    Encrypt = "$ENC$" & ret
End Function

Public Function Decrypt(text As String) As String
    Dim i As Long
    Dim ret As String
    Dim num As Long
    If UCase(Left(text, 5)) <> "$ENC$" Then
        Decrypt = text
        Exit Function
    End If
    
    text = Mid(text, 6)
    ret = Space(Len(text) / 2)
    
    For i = 1 To Len(ret)
        num = Val("&H" & Mid(text, i * 2 - 1, 2)) + 13
        Mid(ret, i, 1) = Chr(num)
    Next i
    
    Decrypt = ret
End Function

Public Sub SetIcon(ByVal hwnd As Long, ByVal sIconResName As String, Optional ByVal bSetAsAppIcon As Boolean = True)
    Dim lhWndTop As Long
    Dim lhWnd As Long
    Dim cx As Long
    Dim cy As Long
    Dim hIconLarge As Long
    Dim hIconSmall As Long
      
    If (bSetAsAppIcon) Then
        ' Find VB's hidden parent window:
        lhWnd = hwnd
        lhWndTop = lhWnd
        Do While Not (lhWnd = 0)
            lhWnd = GetWindow(lhWnd, GW_OWNER)
            If Not (lhWnd = 0) Then
                lhWndTop = lhWnd
            End If
        Loop
    End If
   
    cx = GetSystemMetrics(SM_CXICON)
    cy = GetSystemMetrics(SM_CYICON)
    hIconLarge = LoadImageAsString(App.hInstance, sIconResName, IMAGE_ICON, cx, cy, LR_SHARED)
    If (bSetAsAppIcon) Then
        SendMessageLong lhWndTop, WM_SETICON, ICON_BIG, hIconLarge
    End If
    SendMessageLong hwnd, WM_SETICON, ICON_BIG, hIconLarge
    
    cx = GetSystemMetrics(SM_CXSMICON)
    cy = GetSystemMetrics(SM_CYSMICON)
    hIconSmall = LoadImageAsString(App.hInstance, sIconResName, IMAGE_ICON, cx, cy, LR_SHARED)
    If (bSetAsAppIcon) Then
        SendMessageLong lhWndTop, WM_SETICON, ICON_SMALL, hIconSmall
    End If
    SendMessageLong hwnd, WM_SETICON, ICON_SMALL, hIconSmall
End Sub

Public Sub SetIconLong(ByVal hwnd As Long, ByVal sIconResNumber As Long, Optional ByVal bSetAsAppIcon As Boolean = True)
    Dim lhWndTop As Long
    Dim lhWnd As Long
    Dim cx As Long
    Dim cy As Long
    Dim hIconLarge As Long
    Dim hIconSmall As Long
      
    If (bSetAsAppIcon) Then
        ' Find VB's hidden parent window:
        lhWnd = hwnd
        lhWndTop = lhWnd
        Do While Not (lhWnd = 0)
            lhWnd = GetWindow(lhWnd, GW_OWNER)
            If Not (lhWnd = 0) Then
                lhWndTop = lhWnd
            End If
        Loop
    End If
   
    cx = GetSystemMetrics(SM_CXICON)
    cy = GetSystemMetrics(SM_CYICON)
    hIconLarge = LoadImageLong(App.hInstance, sIconResNumber, IMAGE_ICON, cx, cy, LR_SHARED)
    If (bSetAsAppIcon) Then
        SendMessageLong lhWndTop, WM_SETICON, ICON_BIG, hIconLarge
    End If
    SendMessageLong hwnd, WM_SETICON, ICON_BIG, hIconLarge
    
    cx = GetSystemMetrics(SM_CXSMICON)
    cy = GetSystemMetrics(SM_CYSMICON)
    
    If Screen.TwipsPerPixelX < 15 Or Screen.TwipsPerPixelY < 15 Then
        cx = 32
        cy = 32
    End If
    hIconSmall = LoadImageLong(App.hInstance, sIconResNumber, IMAGE_ICON, cx, cy, LR_SHARED)
    If (bSetAsAppIcon) Then
        SendMessageLong lhWndTop, WM_SETICON, ICON_SMALL, hIconSmall
    End If
    SendMessageLong hwnd, WM_SETICON, ICON_SMALL, hIconSmall
End Sub


