Attribute VB_Name = "modOpenFile"
Option Explicit

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type


Public Function OpenFileDialog(ByVal hwnd As Long, ByRef sFilename As String, ByVal sInitDir As String, ByVal sTitle As String, ByVal sFilter As String)
    Dim OFName As OPENFILENAME
    Dim s As String
    
    OFName.lStructSize = Len(OFName)
    'Set the parent window
    OFName.hwndOwner = hwnd
    'Set the application's instance
    OFName.hInstance = App.hInstance
    'Select a filter
    OFName.lpstrFilter = Replace(sFilter, "|", Chr(0))
    'create a buffer for the file
    OFName.lpstrFile = sFilename & Space(254 - Len(sFilename))
    'set the maximum length of a returned file
    OFName.nMaxFile = 255
    'Create a buffer for the file title
    OFName.lpstrFileTitle = Space(254)
    'Set the maximum length of a returned file title
    OFName.nMaxFileTitle = 255
    'Set the initial directory
    OFName.lpstrInitialDir = sInitDir
    'Set the title
    OFName.lpstrTitle = sTitle
    'No flags
    OFName.flags = 0

    'Show the 'Open File'-dialog
    OpenFileDialog = GetOpenFileName(OFName)
    sFilename = Trim(OFName.lpstrFile)
End Function
