VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Canvas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------------------------------------------------------
'
' OwnerDraw ListBox & ComboBox Controls
'
' Canvas (Canvas.cls)
'
'----------------------------------------------------------------
'
' Author: Eduardo A. Morcillo
' E-Mail: emorcillo@mvps.org
' Web Page: http://www.mvps.org/emorcillo
'
' Distribution: You can freely use this code in your own
'               applications but you can't publish this code in a
'               web site, online service, or any other media,
'               without my express permission.
'
' Usage: at your own risk.
'
' Tested on:
'            * Windows XP Pro SP1
'            * VB6 SP5
'
' History:
'          01/02/2004 - This code was released
'
'---------------------------------------------------------------------------------------
Option Explicit
    
Private m_oPB As PictureBox

Friend Property Get PictureBox() As PictureBox
   Set PictureBox = m_oPB
End Property

Friend Property Set PictureBox(ByVal Value As PictureBox)
   Set m_oPB = Value
End Property

Public Property Get BackColor() As OLE_COLOR
   BackColor = m_oPB.BackColor
End Property
    
Public Property Let BackColor(ByVal Value As OLE_COLOR)
   m_oPB.BackColor = Value
End Property
    
Public Property Get Picture() As StdPicture
   Set Picture = m_oPB.Picture
End Property
    
Public Property Set Picture(ByVal Value As StdPicture)
   Set m_oPB.Picture = Value
End Property
    
Public Property Get ForeColor() As OLE_COLOR
   ForeColor = m_oPB.ForeColor
End Property
    
Public Property Let ForeColor(ByVal Value As OLE_COLOR)
   m_oPB.ForeColor = Value
End Property
    
Public Property Get Width() As Long
   Width = m_oPB.ScaleWidth
End Property
    
Public Property Get Height() As Long
   Height = m_oPB.ScaleHeight
End Property
    
Public Property Get hDC() As Long
   hDC = m_oPB.hDC
End Property

Public Property Get Font() As StdFont
   Set Font = m_oPB.Font
End Property

Public Property Set Font(ByVal Value As StdFont)
   Set m_oPB.Font = Value
End Property

Public Property Get CurrentX() As Long
   CurrentX = m_oPB.CurrentX
End Property

Public Property Let CurrentX(ByVal Value As Long)
   m_oPB.CurrentX = Value
End Property

Public Property Get CurrentY() As Long
   CurrentY = m_oPB.CurrentY
End Property

Public Property Let CurrentY(ByVal Value As Long)
   m_oPB.CurrentY = Value
End Property

Public Property Get FontTransparent() As Boolean
   FontTransparent = m_oPB.FontTransparent
End Property
    
Public Property Let FontTransparent(ByVal Value As Boolean)
   m_oPB.FontTransparent = Value
End Property
    
Public Property Get DrawStyle() As Integer
   DrawStyle = m_oPB.DrawStyle
End Property

Public Property Let DrawStyle(ByVal Value As Integer)
   m_oPB.DrawStyle = Value
End Property

Public Property Get DrawWidth() As Integer
   DrawWidth = m_oPB.DrawWidth
End Property

Public Property Let DrawWidth(ByVal Value As Integer)
   m_oPB.DrawWidth = Value
End Property
    
Public Property Get FillStyle() As Integer
   FillStyle = m_oPB.FillStyle
End Property

Public Property Let FillStyle(ByVal Value As Integer)
   m_oPB.FillStyle = Value
End Property
    
Public Property Get FillColor() As OLE_COLOR
   FillColor = m_oPB.FillColor
End Property
    
Public Property Let FillColor(ByVal Value As OLE_COLOR)
   m_oPB.FillColor = Value
End Property
    
Public Property Get DrawMode() As Integer
   DrawMode = m_oPB.DrawMode
End Property

Public Property Let DrawMode(ByVal Value As Integer)
   m_oPB.DrawMode = Value
End Property
    
Public Sub DrawEllipse( _
   ByVal X As Single, _
   ByVal Y As Single, _
   ByVal Radius As Single)
   
   m_oPB.Circle (X, Y), Radius
   
End Sub

Public Sub Cls()
   m_oPB.Cls
End Sub

Public Sub DrawLine( _
   ByVal X1 As Single, _
   ByVal Y1 As Single, _
   ByVal X2 As Single, _
   ByVal Y2 As Single)
   
   m_oPB.Line (X1, Y1)-(X2, Y2)
   
End Sub
        
Public Sub DrawRect( _
   ByVal X1 As Single, _
   ByVal Y1 As Single, _
   ByVal X2 As Single, _
   ByVal Y2 As Single)
   
   m_oPB.Line (X1, Y1)-(X2, Y2), , B
   
End Sub
        
Public Sub FillRect( _
   ByVal X1 As Single, _
   ByVal Y1 As Single, _
   ByVal X2 As Single, _
   ByVal Y2 As Single)
   
   m_oPB.Line (X1, Y1)-(X2, Y2), , BF
   
End Sub
        
Public Sub PaintPicture( _
   ByVal Picture As StdPicture, _
   ByVal X1 As Long, _
   ByVal Y1 As Long, _
   Optional Width1, _
   Optional Height1, _
   Optional X2, _
   Optional Y2, _
   Optional Width2, _
   Optional Height2, _
   Optional Opcode)

   m_oPB.PaintPicture Picture, X1, Y1, Width1, Height1, X2, Y2, Width2, Height2, Opcode
   
End Sub
                    
Public Function Point( _
   ByVal X As Long, _
   ByVal Y As Long) As OLE_COLOR

   Point = m_oPB.Point(X, Y)
   
End Function
   
Public Sub PSet_( _
   ByVal Step_ As Integer, _
   ByVal X As Long, _
   ByVal Y As Long, _
   ByVal Color As OLE_COLOR)
   
   m_oPB.[PSet] Step_, X, Y, Color
   
End Sub
    
Public Function ScaleX( _
   ByVal Width As Single, _
   Optional ByVal FromScale, _
   Optional ByVal ToScale) As Single
   
   ScaleX = m_oPB.ScaleX(Width, FromScale, ToScale)
   
End Function
    
Public Function ScaleY( _
   ByVal Height As Single, _
   Optional ByVal FromScale, _
   Optional ByVal ToScale) As Single
   
   ScaleY = m_oPB.ScaleY(Height, FromScale, ToScale)

End Function
    
Public Function TextWidth( _
   ByVal Str As String) As Long

   TextWidth = m_oPB.TextWidth(Str)
   
End Function
    
Public Function TextHeight( _
   ByVal Str As String) As Long

   TextHeight = m_oPB.TextHeight(Str)

End Function

Public Function WriteLine(ByVal Str As String)

   m_oPB.Print Str
   
End Function

Public Function WriteString(ByVal Str As String)

   m_oPB.Print Str;
   
End Function


