VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DefaultItemDrawer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------------------------------------------------------
'
' OwnerDraw ListBox & ComboBox Controls
'
' DefaultItemDrawer (DefaultItemDrawer.cls)
'
'----------------------------------------------------------------
'
' Author: Eduardo A. Morcillo
' E-Mail: emorcillo@mvps.org
' Web Page: http://www.mvps.org/emorcillo
'
' Distribution: You can freely use this code in your own
'               applications but you can't publish this code in a
'               web site, online service, or any other media,
'               without my express permission.
'
' Usage: at your own risk.
'
' Tested on:
'            * Windows XP Pro SP1
'            * VB6 SP5
'
' History:
'          01/02/2004 - This code was released
'
'---------------------------------------------------------------------------------------
Option Explicit

Implements IDrawListItem

'----------------------------------------------------------------
' Procedure : IDrawListItem_DrawItem
' Purpose   : Draws the item.
'----------------------------------------------------------------
'
Private Sub IDrawListItem_DrawItem( _
   ByVal Item As ListItem, _
   ByVal Selected As Boolean, _
   ByVal Focused As Boolean, _
   ByVal Canvas As Canvas)
Dim oPB As PictureBox
Dim lX As Long
Dim oPic As StdPicture

   Set oPB = Canvas.PictureBox
   
   With oPB
      
      If Selected Then
         .BackColor = Item.SelectedBackColor
         .ForeColor = Item.SelectedForeColor
         Set oPic = Item.SelectedPicture
         If oPic Is Nothing Then Set oPic = Item.Picture
      Else
         Set oPic = Item.Picture
      End If
      
      If Focused Then
         Dim tR As RECT
         tR.Right = .ScaleWidth
         tR.Bottom = .ScaleHeight
         DrawFocusRect .hDC, tR
      End If
      
      If Not oPic Is Nothing Then
         oPic.Render .hDC, 2, .ScaleHeight - (.ScaleHeight - .ScaleY(oPic.Height, vbHimetric, vbPixels)) / 2, _
            .ScaleX(oPic.Width, vbHimetric, vbPixels), _
            -.ScaleY(oPic.Height, vbHimetric, vbPixels), _
            0, 0, oPic.Width, oPic.Height, ByVal 0&
         lX = 4 + .ScaleX(oPic.Width, vbHimetric, vbPixels)
      Else
         lX = 2
      End If
      
      .CurrentX = lX
      .CurrentY = (.ScaleHeight - .TextHeight(Item.Text)) / 2
      
      oPB.Print Item.Text
      
   End With
   
End Sub

'----------------------------------------------------------------
' Procedure : IDrawListItem_MeasureItem
' Purpose   : Measures the item.
'----------------------------------------------------------------
'
Private Sub IDrawListItem_MeasureItem( _
   ByVal Item As ListItem, _
   ByRef Height As Long, _
   ByVal Canvas As Canvas)
Dim oPB As PictureBox
Dim lH As Long
   
   Set oPB = Canvas.PictureBox
   
   Height = oPB.TextHeight(Item.Text)
   
   If Not Item.Picture Is Nothing Then
      
      lH = oPB.ScaleY(Item.Picture.Height, vbHimetric, vbPixels)
      
      If lH > Height Then Height = lH
      
   End If
   
   If Not Item.SelectedPicture Is Nothing Then
      
      lH = oPB.ScaleY(Item.SelectedPicture.Height, vbHimetric, vbPixels)
      
      If lH > Height Then Height = lH
      
   End If
   
   Height = Height + 4
   
End Sub
