VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------------------------------------------------------
'
' OwnerDraw ListBox & ComboBox Controls
'
' ListItem (ListItem.cls)
'
'----------------------------------------------------------------
'
' Author: Eduardo A. Morcillo
' E-Mail: emorcillo@mvps.org
' Web Page: http://www.mvps.org/emorcillo
'
' Distribution: You can freely use this code in your own
'               applications but you can't publish this code in a
'               web site, online service, or any other media,
'               without my express permission.
'
' Usage: at your own risk.
'
' Tested on:
'            * Windows XP Pro SP1
'            * VB6 SP5
'
' History:
'          01/02/2004 - This code was released
'
'---------------------------------------------------------------------------------------
Option Explicit

Private m_sKey As String
Private m_sText As String
Private m_oPicture As StdPicture
Private m_oPictureSel As StdPicture
Private m_lForeColor As Long
Private m_lBackColor As Long
Private m_lSelectedForeColor As Long
Private m_lSelectedBackColor As Long
Private m_vTag As Variant
Private m_oParent As ICallback

'----------------------------------------------------------------
' Procedure : BackColor
' Purpose   : Gets the color of the item background.
'----------------------------------------------------------------
'
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_UserMemId = -501
   BackColor = m_lBackColor
End Property

'----------------------------------------------------------------
' Procedure : BackColor
' Purpose   : Sets the color of the item background.
'----------------------------------------------------------------
'
Public Property Let BackColor(ByVal Value As OLE_COLOR)
   m_lBackColor = Value
   m_oParent.Refresh
End Property

'----------------------------------------------------------------
' Procedure : EnsureVisible
' Purpose   : Ensures that the item is visible in the ListBox.
'----------------------------------------------------------------
'
Public Sub EnsureVisible()
   m_oParent.EnsureVisible ObjPtr(Me)
End Sub

'----------------------------------------------------------------
' Procedure : ForeColor
' Purpose   : Gets the color of the text of the item.
'----------------------------------------------------------------
'
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_UserMemId = -513
   ForeColor = m_lForeColor
End Property

'----------------------------------------------------------------
' Procedure : ForeColor
' Purpose   : Sets the color of the text of the item.
'----------------------------------------------------------------
'
Public Property Let ForeColor(ByVal Value As OLE_COLOR)
   m_lForeColor = Value
   m_oParent.Refresh
End Property

'----------------------------------------------------------------
' Procedure : Index
' Purpose   : Returns the item index in the Items collection.
'----------------------------------------------------------------
'
Public Property Get Index() As Long
   Index = m_oParent.IndexFromItem(Me) + 1
End Property

'----------------------------------------------------------------
' Procedure : Key
' Purpose   : Returns the item key in the Items collection.
'----------------------------------------------------------------
'
Public Property Get Key() As String
   Key = m_sKey
End Property

'----------------------------------------------------------------
' Procedure : Picture
' Purpose   : Gets the item picture.
'----------------------------------------------------------------
'
Public Property Get Picture() As StdPicture
   Set Picture = m_oPicture
End Property

'----------------------------------------------------------------
' Procedure : Picture
' Purpose   : Sets the item picture.
'----------------------------------------------------------------
'
Public Property Set Picture(ByVal Value As StdPicture)
   Set m_oPicture = Value
   m_oParent.RecalculateItemHeight Me
End Property

'----------------------------------------------------------------
' Procedure : SelectedBackColor
' Purpose   : Gets the color of the item background when the
'             item is selected.
'----------------------------------------------------------------
'
Public Property Get SelectedBackColor() As OLE_COLOR
   SelectedBackColor = m_lSelectedBackColor
End Property

'----------------------------------------------------------------
' Procedure : SelectedBackColor
' Purpose   : Sets the color of the item background when the
'             item is selected.
'----------------------------------------------------------------
'
Public Property Let SelectedBackColor(ByVal Value As OLE_COLOR)
   m_lSelectedBackColor = Value
   m_oParent.Refresh
End Property

'----------------------------------------------------------------
' Procedure : SelectedForeColor
' Purpose   : Gets the color of the item text when the
'             item is selected.
'----------------------------------------------------------------
'
Public Property Get SelectedForeColor() As OLE_COLOR
   SelectedForeColor = m_lSelectedForeColor
End Property

'----------------------------------------------------------------
' Procedure : SelectedForeColor
' Purpose   : Sets the color of the item text when the
'             item is selected.
'----------------------------------------------------------------
'
Public Property Let SelectedForeColor(ByVal Value As OLE_COLOR)
   m_lSelectedForeColor = Value
   m_oParent.Refresh
End Property

'----------------------------------------------------------------
' Procedure : SelectedPicture
' Purpose   : Gets the item picture when the item is selected.
'----------------------------------------------------------------
'
Public Property Get SelectedPicture() As StdPicture
   Set SelectedPicture = m_oPictureSel
End Property

'----------------------------------------------------------------
' Procedure : SelectedPicture
' Purpose   : Sets the item picture when the item is selected.
'----------------------------------------------------------------
'
Public Property Set SelectedPicture(ByVal Value As StdPicture)
   Set m_oPictureSel = Value
   m_oParent.RecalculateItemHeight Me
End Property

'----------------------------------------------------------------
' Procedure : SelectItem
' Purpose   : Selects this item in the list.
'----------------------------------------------------------------
'
Public Sub SelectItem()
   m_oParent.SelectItem ObjPtr(Me)
End Sub

'----------------------------------------------------------------
' Procedure : Tag
' Purpose   : Gets the item tag.
'----------------------------------------------------------------
'
Public Property Get Tag() As Variant
   If IsObject(m_vTag) Then
      Set Tag = m_vTag
   Else
      Tag = m_vTag
   End If
End Property

'----------------------------------------------------------------
' Procedure : Tag
' Purpose   : Sets the item tag.
'----------------------------------------------------------------
'
Public Property Let Tag(ByVal Value As Variant)
   If IsObject(Value) Then
      Set m_vTag = Value
   Else
      m_vTag = Value
   End If
End Property

'----------------------------------------------------------------
' Procedure : Text
' Purpose   : Gets the item text.
'----------------------------------------------------------------
'
Public Property Get Text() As String
Attribute Text.VB_UserMemId = 0
   Text = m_sText
End Property

'----------------------------------------------------------------
' Procedure : Text
' Purpose   : Sets the item text.
'----------------------------------------------------------------
'
Public Property Let Text(ByVal Value As String)
   m_sText = Value
   m_oParent.RecalculateItemHeight ObjPtr(Me)
End Property

'----------------------------------------------------------------
' Procedure : Initialize
' Purpose   : Initializes the class.
'----------------------------------------------------------------
'
Friend Sub Initialize( _
   Text As String, _
   Image As StdPicture, _
   ImageSel As StdPicture, _
   ByVal ForeColor As Long, _
   ByVal BackColor As Long, _
   ByVal SelForeColor As Long, _
   ByVal SelBackColor As Long, _
   Key As Variant, _
   Parent As ICallback)

   m_sText = Text
   Set m_oPicture = Image
   Set m_oPictureSel = ImageSel
   m_lForeColor = ForeColor
   m_lBackColor = BackColor
   m_lSelectedForeColor = SelForeColor
   m_lSelectedBackColor = SelBackColor
   If Not IsMissing(Key) Then m_sKey = CStr(Key)
   
   Set m_oParent = Parent
   
End Sub

Private Sub m_oFont_FontChanged(ByVal PropertyName As String)
   m_oParent.RecalculateItemHeight ObjPtr(Me)
End Sub
