Attribute VB_Name = "mdlMain"
'----------------------------------------------------------------
'
' OwnerDraw ListBox & ComboBox Controls
'
' mdlMain (mdlMain.bas)
'
'----------------------------------------------------------------
'
' Author: Eduardo A. Morcillo
' E-Mail: emorcillo@mvps.org
' Web Page: http://www.mvps.org/emorcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested on:
'            * Windows XP Pro SP1
'            * VB6 SP5
'
' History:
'          01/02/2004 - This code was released
'
'----------------------------------------------------------------
Option Explicit

' ----==== ListBox API ====----

' ---- Notification Codes ----

'Public Const LBN_ERRSPACE = (-2)
Public Const LBN_SELCHANGE = 1
Public Const LBN_DBLCLK = 2
'Public Const LBN_SELCANCEL = 3
'Public Const LBN_SETFOCUS = 4
'Public Const LBN_KILLFOCUS = 5

' ---- Messages ----

Public Const LB_ADDSTRING = &H180
Public Const LB_INSERTSTRING = &H181
Public Const LB_DELETESTRING = &H182
'Public Const LB_SELITEMRANGEEX = &H183
Public Const LB_RESETCONTENT = &H184
'Public Const LB_SETSEL = &H185
Public Const LB_SETCURSEL = &H186
'Public Const LB_GETSEL = &H187
Public Const LB_GETCURSEL = &H188
'Public Const LB_GETTEXT = &H189
'Public Const LB_GETTEXTLEN = &H18A
'Public Const LB_GETCOUNT = &H18B
'Public Const LB_SELECTSTRING = &H18C
'Public Const LB_DIR = &H18D
'Public Const LB_GETTOPINDEX = &H18E
'Public Const LB_FINDSTRING = &H18F
'Public Const LB_GETSELCOUNT = &H190
'Public Const LB_GETSELITEMS = &H191
'Public Const LB_SETTABSTOPS = &H192
'Public Const LB_GETHORIZONTALEXTENT = &H193
'Public Const LB_SETHORIZONTALEXTENT = &H194
'Public Const LB_SETCOLUMNWIDTH = &H195
'Public Const LB_ADDFILE = &H196
Public Const LB_SETTOPINDEX = &H197
'Public Const LB_GETITEMRECT = &H198
'Public Const LB_GETITEMDATA = &H199
'Public Const LB_SETITEMDATA = &H19A
'Public Const LB_SELITEMRANGE = &H19B
'Public Const LB_SETANCHORINDEX = &H19C
'Public Const LB_GETANCHORINDEX = &H19D
'Public Const LB_SETCARETINDEX = &H19E
'Public Const LB_GETCARETINDEX = &H19F
Public Const LB_SETITEMHEIGHT = &H1A0
'Public Const LB_GETITEMHEIGHT = &H1A1
Public Const LB_FINDSTRINGEXACT = &H1A2
'Public Const LB_SETLOCALE = &H1A5
'Public Const LB_GETLOCALE = &H1A6
'Public Const LB_SETCOUNT = &H1A7
'Public Const LB_MSGMAX = &H1A8

' ---- Styles ----

Public Const LBS_NOTIFY = &H1&
Public Const LBS_SORT = &H2&
Public Const LBS_NOREDRAW = &H4&
'Public Const LBS_MULTIPLESEL = &H8&
'Public Const LBS_OWNERDRAWFIXED = &H10&
Public Const LBS_OWNERDRAWVARIABLE = &H20&
'Public Const LBS_HASSTRINGS = &H40&
'Public Const LBS_USETABSTOPS = &H80&
Public Const LBS_NOINTEGRALHEIGHT = &H100&
'Public Const LBS_MULTICOLUMN = &H200&
'Public Const LBS_WANTKEYBOARDINPUT = &H400&
'Public Const LBS_EXTENDEDSEL = &H800&
'Public Const LBS_DISABLENOSCROLL = &H1000&
'Public Const LBS_NODATA = &H2000&

' ----==== ComboBox API ====----
 
' ---- Notification Codes ----

'Public Const CBN_ERRSPACE = -1
Public Const CBN_SELCHANGE = 1
Public Const CBN_DBLCLK = 2
'Public Const CBN_SETFOCUS = 3
'Public Const CBN_KILLFOCUS = 4
Public Const CBN_EDITCHANGE = 5
'Public Const CBN_EDITUPDATE = 6
Public Const CBN_DROPDOWN = 7
Public Const CBN_CLOSEUP = 8
'Public Const CBN_SELENDOK = 9
'Public Const CBN_SELENDCANCEL = 10

' ---- Styles ----
 
Public Const CBS_SIMPLE = &H1
Public Const CBS_DROPDOWN = &H2
Public Const CBS_DROPDOWNLIST = &H3
'Public Const CBS_OWNERDRAWFIXED = &H10
Public Const CBS_OWNERDRAWVARIABLE = &H20
'Public Const CBS_AUTOHSCROLL = &H40
'Public Const CBS_OEMCONVERT = &H80
Public Const CBS_SORT = &H100
'Public Const CBS_HASSTRINGS = &H200
Public Const CBS_NOINTEGRALHEIGHT = &H400
'Public Const CBS_DISABLENOSCROLL = &H800
'Public Const CBS_UPPERCASE = &H2000
'Public Const CBS_LOWERCASE = &H4000

' ---- Combo Box messages ----

Public Const CB_GETEDITSEL = &H140
Public Const CB_LIMITTEXT = &H141
Public Const CB_SETEDITSEL = &H142
Public Const CB_ADDSTRING = &H143
Public Const CB_DELETESTRING = &H144
Public Const CB_DIR = &H145
Public Const CB_GETCOUNT = &H146
Public Const CB_GETCURSEL = &H147
Public Const CB_GETLBTEXT = &H148
Public Const CB_GETLBTEXTLEN = &H149
Public Const CB_INSERTSTRING = &H14A
Public Const CB_RESETCONTENT = &H14B
Public Const CB_FINDSTRING = &H14C
Public Const CB_SELECTSTRING = &H14D
Public Const CB_SETCURSEL = &H14E
Public Const CB_SHOWDROPDOWN = &H14F
Public Const CB_GETITEMDATA = &H150
Public Const CB_SETITEMDATA = &H151
Public Const CB_GETDROPPEDCONTROLRECT = &H152
Public Const CB_SETITEMHEIGHT = &H153
Public Const CB_GETITEMHEIGHT = &H154
Public Const CB_SETEXTENDEDUI = &H155
Public Const CB_GETEXTENDEDUI = &H156
Public Const CB_GETDROPPEDSTATE = &H157
Public Const CB_FINDSTRINGEXACT = &H158
'Public Const CB_SETLOCALE = &H159
'Public Const CB_GETLOCALE = &H15A
'Public Const CB_GETTOPINDEX = &H15B
Public Const CB_SETTOPINDEX = &H15C
'Public Const CB_GETHORIZONTALEXTENT = &H15D
'Public Const CB_SETHORIZONTALEXTENT = &H15E
'Public Const CB_GETDROPPEDWIDTH = &H15F
'Public Const CB_SETDROPPEDWIDTH = &H160
'Public Const CB_INITSTORAGE = &H161
'Public Const CB_MULTIPLEADDSTRING = &H163
'Public Const CB_GETCOMBOBOXINFO = &H164

' ----==== User32 API ====----

Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Declare Function RedrawWindow Lib "user32" (ByVal hWnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long

' ---- RedrawWindow Flags ----

Public Const RDW_INVALIDATE = &H1
'Public Const RDW_INTERNALPAINT = &H2
Public Const RDW_ERASE = &H4
'Public Const RDW_VALIDATE = &H8
'Public Const RDW_NOINTERNALPAINT = &H10
Public Const RDW_NOERASE = &H20
'Public Const RDW_NOCHILDREN = &H40
'Public Const RDW_ALLCHILDREN = &H80
Public Const RDW_UPDATENOW = &H100
Public Const RDW_ERASENOW = &H200
'Public Const RDW_FRAME = &H400
'Public Const RDW_NOFRAME = &H800

Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Function SetFocusAPI Lib "user32" Alias "SetFocus" (ByVal hWnd As Long) As Long

Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

' ---- SetWindowPos Flags ----

Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_FRAMECHANGED = &H20

Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

' ---- Get/SetWindowLong Flags ----

Public Const GWL_WNDPROC = (-4)
Public Const GWL_EXSTYLE = (-20)
Public Const GWL_STYLE = (-16)

Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long

Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, lpRect As RECT) As Long

' ---- Window Styles ----

Public Const WS_CHILD = &H40000000
Public Const WS_VISIBLE = &H10000000
Public Const WS_BORDER = &H800000
Public Const WS_VSCROLL = &H200000
Public Const WS_HSCROLL = &H100000
Public Const WS_GROUP = &H20000
Public Const WS_TABSTOP = &H10000
Public Const WS_EX_RTLREADING = &H2000&
Public Const WS_EX_LEFTSCROLLBAR = &H4000&
Public Const WS_EX_CLIENTEDGE = &H200&
Public Const WS_EX_STATICEDGE = &H20000

' ---- Window Messages ----

Public Const WM_SETFOCUS = &H7
Public Const WM_KILLFOCUS = &H8
Public Const WM_CTLCOLORLISTBOX = &H134
Public Const WM_DRAWITEM = &H2B
Public Const WM_MEASUREITEM = &H2C
Public Const WM_COMMAND = &H111
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208
Public Const WM_MOUSEMOVE = &H200
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Public Const WM_CHAR = &H102
Public Const WM_SETFONT = &H30
Public Const WM_VSCROLL = &H115
Public Const WM_COMPAREITEM = &H39

' ---- Owner draw state ----

Public Const ODS_SELECTED = &H1
Public Const ODS_GRAYED = &H2
Public Const ODS_DISABLED = &H4
Public Const ODS_CHECKED = &H8
Public Const ODS_FOCUS = &H10

' ---- Structures ----

Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Type MEASUREITEMSTRUCT
   CtlType As Long
   CtlID As Long
   ItemID As Long
   ItemWidth As Long
   ItemHeight As Long
   ItemData As Long
End Type

Type DRAWITEMSTRUCT
   CtlType As Long
   CtlID As Long
   ItemID As Long
   itemAction As Long
   itemState As Long
   hwndItem As Long
   hDC As Long
   rcItem As RECT
   ItemData As Long
End Type

Type COMPAREITEMSTRUCT
   CtlType As Long
   CtlID As Long
   hwndItem As Long
   itemID1 As Long
   itemData1 As Long
   itemID2 As Long
   itemData2 As Long
   dwLocaleId As Long
End Type
' ----==== GDI API ====----

Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

' ----==== Other APIs ====----

Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

' ----==== Private Constants ====----

Private Const WNDPROC_PROP = "WndProc"
Private Const CALLBACK_PROP = "Callback"

'----------------------------------------------------------------
' Procedure : WinProc
' Purpose   : New window procedure for subclassed windows
'----------------------------------------------------------------
'
Private Function WinProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim lPtr As Long
Dim oCallback As ICallback

   On Error Resume Next
   
   lPtr = GetProp(hWnd, CALLBACK_PROP)
   MoveMemory oCallback, lPtr, 4
   
   WinProc = oCallback.WindowProc(hWnd, uMsg, wParam, lParam)
   
   MoveMemory oCallback, 0&, 4
       
End Function

'----------------------------------------------------------------
' Procedure : SubclassWindow
' Purpose   : Subclasses a window
'----------------------------------------------------------------
'
Public Function SubclassWindow(ByVal hWnd As Long, ByVal Callback As ICallback) As Long

   ' Store current window procedure
   SetProp hWnd, WNDPROC_PROP, GetWindowLong(hWnd, GWL_WNDPROC)
   
   ' Store callback pointer
   SetProp hWnd, CALLBACK_PROP, ObjPtr(Callback)
   
   ' Subclass the window
   SubclassWindow = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf mdlMain.WinProc)
   
End Function

'----------------------------------------------------------------
' Procedure : UnsubclassWindow
' Purpose   : Unsubclasses a window
'----------------------------------------------------------------
'
Public Sub UnsubclassWindow(ByVal hWnd As Long)
Dim lProc As Long

   ' Get original window procedure
   lProc = GetProp(hWnd, WNDPROC_PROP)
   
   ' Restore window procedure
   SetWindowLong hWnd, GWL_WNDPROC, lProc
   
   ' Remove the properties
   RemoveProp hWnd, WNDPROC_PROP
   RemoveProp hWnd, CALLBACK_PROP
   
End Sub

'----------------------------------------------------------------
' Procedure : OleClr2ClrRef
' Purpose   : Converts an OLE_COLOR to RGB
'----------------------------------------------------------------
'
Public Function OleClr2ClrRef(ByVal Clr As OLE_COLOR) As Long
   OleTranslateColor Clr, 0, OleClr2ClrRef
End Function

'----------------------------------------------------------------
' Procedure : ItemFromPtr
' Purpose   : Returns a counted reference of a ListItem from a
'             pointer
'----------------------------------------------------------------
'
Public Function ItemFromPtr(ByVal Ptr As Long) As ListItem
Dim oItem As ListItem

   If Ptr Then
      MoveMemory oItem, Ptr, 4&
      Set ItemFromPtr = oItem
      MoveMemory oItem, 0&, 4&
   End If
   
End Function
